param N;
param T;
param a{i in 1..N};
param b{i in 1..N};
param c{i in 1..N};
param d{t in 1..T};
param g{i in 1..N};
param xmin{i in 1..N};
param xmax{i in 1..N};
param uptime{i in 1..N};
param downtime{i in 1..N};

var x{i in 1..N, t in 1..T} >=0;
var u{i in 1..N, t in 0..T} binary; 
var v{i in 1..N, t in 1..T} >=0; 

minimize cost: sum{i in 1..N, t in 1..T}(a[i]*x[i,t]*x[i,t]+b[i]*x[i,t])
+sum{i in 1..N, t in 1..T}(c[i]*u[i,t])
+sum{i in 1..N, t in 1..T}g[i]*v[i,t];

subject to demand{t in 1..T}: sum{i in 1..N}x[i,t] >= d[t];
subject to minoutput{i in 1..N, t in 1..T}: # L;
subject to maxoutput{i in 1..N, t in 1..T}: # L;

subject to minup{i in 1..N, t in 2..T, s in t+1..min(t+uptime[i]-1,T)}: u[i,t]-u[i,t-1] <= u[i,s];
subject to mindown{i in 1..N, t in 2..T, s in t+1..min(t+downtime[i]-1,T)}:#L;
subject to uv{i in 1..N, t in 1..T}: u[i,t]-u[i,t-1] <= v[i,t];
subject to init_u {i in 1..N}: u[i,0]=0;







